using System;
using System.Data;

using System.Data.SqlClient;
using System.Configuration;
using System.Web;
using System.Web.UI;
using Sql.DataAccessLayer;
using System.Text;
using System.Collections.Generic;
using System.Web.Caching;
using System.Text.RegularExpressions;
using System.Text;

/// <summary>
/// Summary description for TagsBLL
/// </summary>
public class TagsBLL
{
   private UtilityBLL _utility = new UtilityBLL();


   // Note: tags Important Terms
    
   // Status:
   // ........... 0: Tag is inactive
   // ........... 1: Tag is active
   // ............2: All

   // Type:
   // ........... 0: Videos
   // ........... 1: Groups
   // ........... 2: Photos | Galleries
   // ........... 3: Blogs
   // ........... 4: Audio Files
   // ........... 5: Generalize
   // ........... 6: Galleries
   // .......... 7: Forums
   // .......... 8: Video Album
    // ......... 9: Audio Album
    // .......... 11: Q&A
   // ......... 100: All
   // Tag Type:
   //............. 0: normal tags
   // ............ 1: user searches
   // ............ 2: all
   // Tag Level
   // ............ 0: high
   // ............ 1: medium
   // ............ 2: low
   // ............ 100: all
 
	public TagsBLL()
	{
		//
		// TODO: Add constructor logic here
		//
	}

    public static bool Add(string tagname,int type,int records,string term)
    {
        //SqlHelper.ExecuteNonQuery(Config.ConnectionString, CommandType.StoredProcedure, "VSK_TAGS_Post2", new SqlParameter("@tagname", tagname), new SqlParameter("@type", type), new SqlParameter("@records", records),new SqlParameter("@term",term));
        SqlHelper.ExecuteNonQuery(Config.ConnectionString, CommandType.Text, "Insert Into tags(tagname,type,records,term)values(@tagname,@type,@records,@term);", new SqlParameter("@tagname", tagname), new SqlParameter("@type", type), new SqlParameter("@records", records), new SqlParameter("@term", term));
       return true;
    }


    public static bool Add(string tagname, int type, int records, int tag_type, int status, string term)
    {
        //SqlHelper.ExecuteNonQuery(Config.ConnectionString, CommandType.StoredProcedure, "VSK_TAGS_Post", new SqlParameter("@tagname", tagname), new SqlParameter("@type", type), new SqlParameter("@records", records), new SqlParameter("@tag_type", tag_type), new SqlParameter("@status", status), new SqlParameter("@term", term));
        SqlHelper.ExecuteNonQuery(Config.ConnectionString, CommandType.Text, "Insert Into tags(tagname,type,records,tag_type,status,term)values(@tagname,@type,@records,@tag_type,@status,@term);", new SqlParameter("@tagname", tagname), new SqlParameter("@type", type), new SqlParameter("@records", records), new SqlParameter("@tag_type", tag_type), new SqlParameter("@status", status), new SqlParameter("@term", term));
        return true;
    }


    public static bool Delete(int tagid)
    {
        SqlHelper.ExecuteNonQuery(Config.ConnectionString, CommandType.Text, "Delete from tags where tagid=@tagid",new SqlParameter("@tagid",tagid));
        return true;
    }

    public static bool Delete_Inactive()
    {
        SqlHelper.ExecuteNonQuery(Config.ConnectionString, CommandType.Text, "Delete from tags where status=0");
        return true;
    }


    public static int Count_Admin_Tags(string search, string tag_level, int type, string status, string tag_type)
    {
        StringBuilder str = new StringBuilder();
        str.Append("SELECT Count(tagid) from tags where type=" + type + "");
        if (search != "")
            str.Append(" AND tagname like '%" + search + "%'");
        if (tag_level != "all")
            str.Append(" AND tag_level=" + tag_level + "");
        if (status != "all")
            str.Append(" AND status=" + status + "");
        if (tag_type != "all")
            str.Append(" AND tag_type=" + tag_type + "");

        return Convert.ToInt32(SqlHelper.ExecuteScalar(Config.ConnectionString, CommandType.Text, str.ToString()));
    }
    public static List<Tags_Struct> Load_Admin_V2(string search, string tag_level, int type, string status, string tag_type, int order_index, int PageNumber, int PageSize)
    {
        // Query Building
        StringBuilder str = new StringBuilder();
        StringBuilder query = new StringBuilder();
        query.Append("* from tags where type=" + type + "");
        if (search != "")
            query.Append(" AND tagname like '%" + search + "%'");
        if (tag_level != "all")
            query.Append(" AND tag_level=" + tag_level + "");
        if (status != "all")
            query.Append(" AND status=" + status + "");
        if (tag_type != "all")
            query.Append(" AND tag_type=" + tag_type + "");

        string index = "status ASC";
        switch (order_index)
        {
            case 0:
                index = "status ASC";
                break;
            case 1:
                index = "tagname ASC";
                break;
            case 2:
                index = "tagname DESC";
                break;
            case 3:
                index = "records DESC";
                break;
            case 4:
                index = "tagid DESC";
                break;
            case 5:
                index = "tag_type DESC";
                break;
        }
        // implement paging script for differnt data sources.
        switch (Config.Return_PaginationType())
        {
            case 0:
                // SQL SERVER 2005 or Later Supported Query
                str.Append(Pagination_Process.Prepare_SQLSERVER2005_Pagination(query.ToString(), index, PageNumber, PageSize));
                break;
            case 1:
                // MySQL Supported Query
                string mysql_query = "SELECT " + query.ToString() + " ORDER BY " + index;
                str.Append(Pagination_Process.Prepare_MySQL_Pagination(mysql_query, PageNumber, PageSize));
                break;
            case 2:
                // SQL SERVER 2000 Supported Query
                string normal_query = "SELECT " + query.ToString() + " ORDER BY " + index;
                str.Append(normal_query);
                break;
        }
        SqlConnection con = new SqlConnection(Config.ConnectionString);
        if (con.State != ConnectionState.Open) con.Open();
        List<Tags_Struct> _items = new List<Tags_Struct>();
        Tags_Struct _item;
        // execute sql query
        SqlCommand video_cmd = new SqlCommand(str.ToString(), con);
        SqlDataReader reader = video_cmd.ExecuteReader(CommandBehavior.CloseConnection);
        while (reader.Read())
        {
            _item = new Tags_Struct();
            _item.TagID = (int)reader["TagID"];
            _item.Tag_Level = Convert.ToInt32(reader["Tag_Level"]);
            _item.TagName = reader["TagName"].ToString();
            _item.Priority = Convert.ToInt32(reader["periority"]);
            _item.Records = Convert.ToInt32(reader["Records"]);
            _item.Status = Convert.ToInt32(reader["Status"]);
            _items.Add(_item);
        }
        reader.Close();
        con.Close(); con.Dispose();

        return _items;
    }
    
    public static bool Update_Tag_Status(int tagid,string tagname,int status,int tag_level, int periority)
    {
       SqlHelper.ExecuteNonQuery(Config.ConnectionString, CommandType.Text, "Update tags set tagname=@tagname,status=@status,tag_level=@tag_level,periority=@periority where tagid=@tagid",new SqlParameter("@tagname",tagname), new SqlParameter("@tagid", tagid),new SqlParameter("@status",status),new SqlParameter("@tag_level",tag_level),new SqlParameter("@periority",periority));
       return true;
    }

    public static bool Update_Tag_Level(int tagid,int status, int tag_level)
    {
        SqlHelper.ExecuteNonQuery(Config.ConnectionString, CommandType.Text, "Update tags set tag_level=@taglevel,status=@status where tagid=@tagid",new SqlParameter("@tagid",tagid),new SqlParameter("@status",status),new SqlParameter("@taglevel",tag_level));
        return true;
    }

    public static bool Update_Records(int tagid, int records)
    {
        SqlHelper.ExecuteNonQuery(Config.ConnectionString, CommandType.Text, "Update tags set records=@records where tagid=" + tagid + "",new SqlParameter("@records",records)); 
        return true;
    }


    // update total no of records available for tag.
    public static bool Process_Records(string tagname,int type)
    {
        int count_records = TagsBLL.Count_Tags(tagname, type);
        SqlHelper.ExecuteNonQuery(Config.ConnectionString, CommandType.Text, "Update tags set records=@count where tagname=@tagname AND type=@type",new SqlParameter("@type",type),new SqlParameter("@tagname",tagname),new SqlParameter("@count",count_records));
        return true;
    }
      

    //public static int Count_Tags()
    //{
    //    return Convert.ToInt32(SqlHelper.ExecuteScalar(Config.ConnectionString, CommandType.Text, "SELECT Count(tagid) from tags"));
    //}

    public static bool Check_Tag(string Tag)
    {
        int result = Convert.ToInt32(SqlHelper.ExecuteScalar(Config.ConnectionString, CommandType.Text, "Select count(tagid) from tags Where tagname=@tagname",new SqlParameter("@tagname",Tag)));
        if (result > 0)
            return true;
        else
            return false;
    }

    public static bool Check_Tag(string Tag, int type)
    {
        int result = Convert.ToInt32(SqlHelper.ExecuteScalar(Config.ConnectionString, CommandType.Text, "Select count(tagid) from tags Where tagname=@tagname AND type=@type",new SqlParameter("@tagname",Tag),new SqlParameter("@type",type)));
        if (result > 0)
            return true;
        else
            return false;
    }

    public static bool Check_Tag(string Tag,int type,int tag_type)
    {
        int result = Convert.ToInt32(SqlHelper.ExecuteScalar(Config.ConnectionString, CommandType.Text, "Select count(tagid) from tags Where tagname=@tagname AND type=@type AND tag_type=@tag_type",new SqlParameter("@tag_type",tag_type),new SqlParameter("@type",type),new SqlParameter("@tagname",Tag)));
        if (result > 0)
            return true;
        else
            return false;
    }


    public static bool Activate_All_Tags(int type)
    {
        SqlHelper.ExecuteNonQuery(Config.ConnectionString, CommandType.Text, "Update tags set status=1 where status=0 AND type=@type",new SqlParameter("@type",type));
        return true;
    }


    public static int Count_Tags(string tagname, int type)
    {
        int count = 0;
        switch (type)
        {
            case 0:
                // videos
                //count = Convert.ToInt32(SqlHelper.ExecuteScalar(Config.ConnectionString, CommandType.StoredProcedure, "VSK_TAGS_Video_Count", new SqlParameter("@tagname", "'%" + tagname + "%'")));
                count = Convert.ToInt32(SqlHelper.ExecuteScalar(Config.ConnectionString, CommandType.Text, "SELECT count(VideoID) from videos where tags like @tagname AND isPrivate=0 AND isEnabled=1 AND ispublished=1 AND isreviewed=1", new SqlParameter("@tagname", "'%" + tagname + "%'")));
                break;
            case 1:
                // groups
                //count = Convert.ToInt32(SqlHelper.ExecuteScalar(Config.ConnectionString, CommandType.StoredProcedure, "VSK_Tags_Group_Count", new SqlParameter("@tagname", "'%" + tagname + "%'")));
                count = Convert.ToInt32(SqlHelper.ExecuteScalar(Config.ConnectionString, CommandType.Text, "SELECT count(groupid) from groups where tags like @tagname AND isenable=1 AND isApproved=1", new SqlParameter("@tagname", "'%" + tagname + "%'")));
                break;
            case 2:
                // photos
                //count = Convert.ToInt32(SqlHelper.ExecuteScalar(Config.ConnectionString, CommandType.StoredProcedure, "VSK_Tags_Photo_Count", new SqlParameter("@tagname", "'%" + tagname + "%'")));
                count = Convert.ToInt32(SqlHelper.ExecuteScalar(Config.ConnectionString, CommandType.Text, "SELECT count(imageid) from photos where tags like @tagname AND isdisabled=1 AND isApproved=1", new SqlParameter("@tagname", "'%" + tagname + "%'")));
                break;
            case 3:
                // blogs
                //count = Convert.ToInt32(SqlHelper.ExecuteScalar(Config.ConnectionString, CommandType.StoredProcedure, "VSK_Tags_Blog_Count", new SqlParameter("@tagname", "'%" + tagname + "%'")));
                count = Convert.ToInt32(SqlHelper.ExecuteScalar(Config.ConnectionString, CommandType.Text, "SELECT count(postid) from blogs where tags like @tagname AND isdisabled=1 AND isApproved=1", new SqlParameter("@tagname", "'%" + tagname + "%'")));
                break;
            case 6:
                // galleries
                //count = Convert.ToInt32(SqlHelper.ExecuteScalar(Config.ConnectionString, CommandType.Text, "VSK_Tags_Gallery_Count", new SqlParameter("@tagname", "'%" + tagname + "%'")));
                count = Convert.ToInt32(SqlHelper.ExecuteScalar(Config.ConnectionString, CommandType.Text, "SELECT count(galleryid) from galleries where tags like @tagname AND isdisabled=1 AND isApproved=1", new SqlParameter("@tagname", "'%" + tagname + "%'")));
                break;
            case 7:
                // forums
                //count = Convert.ToInt32(SqlHelper.ExecuteScalar(Config.ConnectionString, CommandType.Text, "VSK_Tags_Forum_Count", new SqlParameter("@tagname", "'%" + tagname + "%'")));
                count = Convert.ToInt32(SqlHelper.ExecuteScalar(Config.ConnectionString, CommandType.Text, "SELECT count(topicid) from forum_topics where tags like @tagname AND isenabled=1 AND isApproved=1", new SqlParameter("@tagname", "'%" + tagname + "%'")));
                break;
            case 11:
                // qa
                //count = Convert.ToInt32(SqlHelper.ExecuteScalar(Config.ConnectionString, CommandType.Text, "VSK_Tags_QA_Count", new SqlParameter("@tagname", "'%" + tagname + "%'")));
                count = Convert.ToInt32(SqlHelper.ExecuteScalar(Config.ConnectionString, CommandType.Text, "SELECT count(qid) from qa where tags like @tagname AND isenabled=1 AND isApproved=1", new SqlParameter("@tagname", "'%" + tagname + "%'")));
                break;
        }
        return count;
    }

    // Core function to process content related tags
    public static void Process_Tags(string tags,int type,int tag_type)
    {
        // process tags
        string[] arr;
        arr = tags.ToString().Split(char.Parse(","));
        int j = 0;
        for (j = 0; j <= arr.Length - 1; j++)
        {
            // if tag length greater than 3 characters
            if (arr[j].Length > 3)
            {
                // if tag not already exist
                string term = UtilityBLL.CleanSearchTerm(arr[j].ToString().Trim());
                if (!Check_Tag(term, type, tag_type))
                {
                    // insert each tag into tags table
                    int records = 1; // show one record in start by selected tag
                    if(tag_type==1)
                        Add(arr[j].ToString(), type, records,tag_type,1,term);
                    else
                        Add(arr[j].ToString(), type, records,term);
                }
                else
                {
                    // tag exist - update tag records
                    // Due to performance issue, don't enable it on front line. update tag statistics from control panel
                    // Process_Records(arr[j].ToString(), type);
                }
            }
        }
    }


    // Script to check whether each tag user input has exceed maximum limit of 35 characters.
    public static bool Validate_Tags(string tags)
    {
        bool flag = true;
        // process tags
        if (tags.Contains(","))
        {
            string[] arr;
            arr = tags.ToString().Split(char.Parse(","));
            int j = 0;
            for (j = 0; j <= arr.Length - 1; j++)
            {
                // if tag length greater than 20 characters
                if (arr[j].Length > 35)
                    flag = false;
            }
        }
        else
        {
            if (tags.Length > 35)
                flag = false;
        }
        return flag;
    }

    ////************************************************************
    // TAG Listing Script
    //**************************************************************
    // cache version
    public static List<Tags_Struct> Cache_FetchRecentTags_V2(string term, int type, int tag_type, int tag_level, int isenabled, int records, int pagenumber, string order, bool iscahe)
    {
        // cache implementation
        int cache_duration = Config.GetCacheDuration();
        if (cache_duration == 0 || !iscahe) // no cache
            return FetchRecentTags_V2(term, type, tag_type, tag_level, isenabled, records, pagenumber, order);
        else
        {
            string cach_key = "ld_tg_" + type + "" + tag_type + "" + tag_level + "" + isenabled + "" + records + "" + pagenumber + "" + order;
            if (term != "")
                cach_key = cach_key + UtilityBLL.ReplaceSpaceWithHyphin(term);
            if (HttpContext.Current.Cache[cach_key] == null)
                HttpContext.Current.Cache.Add(cach_key, FetchRecentTags_V2(term, type, tag_type, tag_level, isenabled, records, pagenumber, order), null, DateTime.Now.AddMinutes(cache_duration), TimeSpan.Zero, CacheItemPriority.High, null);

            List<Tags_Struct> _list = (List<Tags_Struct>)(HttpContext.Current.Cache[cach_key]);
            return _list;
        }

    }
    // Load Tags Based On Wide Variety of Options
    public static List<Tags_Struct> FetchRecentTags_V2(string term, int type, int tag_type, int tag_level, int isenabled, int records, int pagenumber, string order)
    {
        SqlConnection con = new SqlConnection(Config.ConnectionString);
        if (con.State != ConnectionState.Open) con.Open();
        List<Tags_Struct> _items = new List<Tags_Struct>();
        Tags_Struct _item;

        // generate sql query
        StringBuilder str = new StringBuilder();
        StringBuilder query = new StringBuilder();
        query.Append("tagid,tagname,term,records from tags " + Fetch_Tag_Logic(term, type, tag_type, tag_level, isenabled));
          // load all records based on pagination
        switch (Config.Return_PaginationType())
        {
            case 0:
                // SQL SERVER 2005 or Later Supported Query
                str.Append(Pagination_Process.Prepare_SQLSERVER2005_Pagination(query.ToString(), order, pagenumber, records));
                break;
            case 1:
                // MySQL Supported Query
                string mysql_query = "SELECT " + query.ToString() + " ORDER BY " + order;
                str.Append(Pagination_Process.Prepare_MySQL_Pagination(mysql_query, pagenumber, records));
                break;
            case 2:
                // SQL SERVER 2000 Supported Query
                string normal_query = "SELECT " + query.ToString() + " ORDER BY " + order;
                str.Append(normal_query);
                break;
        }
       

        // execute sql query
        SqlCommand video_cmd = new SqlCommand(str.ToString(), con);
        SqlDataReader reader = video_cmd.ExecuteReader(CommandBehavior.CloseConnection);
        while (reader.Read())
        {
            _item = new Tags_Struct();
            _item.TagID = Convert.ToInt32(reader["tagid"]);
            _item.TagName = reader["tagname"].ToString();
            _item.Records = (int)reader["records"];
            _item.Term = reader["term"].ToString();
            _items.Add(_item);
        }
        reader.Close();
        con.Close(); con.Dispose();

        return _items;
    }

    public static int CountRecentTags_V2(string term, int type, int tag_type, int tag_level, int isenabled)
    {
        StringBuilder str = new StringBuilder();
        str.Append("SELECT count(tagid) From tags " + Fetch_Tag_Logic(term, type, tag_type, tag_level, isenabled));
        return Convert.ToInt32(SqlHelper.ExecuteScalar(Config.ConnectionString, CommandType.Text, str.ToString()));
    }

    private static string Fetch_Tag_Logic(string term, int type, int tag_type, int tag_level, int isenabled)
    {
        StringBuilder query = new StringBuilder();
        if (type != 100 || tag_type != 2 || tag_level != 100 || isenabled != 2 || term != "")
            query.Append(" where");
        if (type != 100)
        {
            query.Append(" (type=" + type + " OR type=5)");
            if (tag_type != 2 || tag_level != 100 || isenabled != 2 || term != "")
                query.Append(" and");
        }
        if (tag_type != 2)
        {
            query.Append(" tag_type=" + tag_type + "");
            if (tag_level != 100 || isenabled != 2 || term != "")
                query.Append(" and");
        }
        if (tag_level != 100)
        {
            query.Append(" tag_level=" + tag_level + "");
            if (isenabled != 2 || term != "")
                query.Append(" and");
        }
        if (isenabled != 2)
        {
            query.Append(" status=" + isenabled + "");
            if (term != "")
                query.Append(" and");
        }
        if (term != "")
        {
            query.Append(" tagname like '%" + term.Trim() + "%'");
        }
        return query.ToString();
    }


    //********************************************************************************************
    // CLOSE TAG LISTING SCRIPT
    //********************************************************************************************

    // load tags for autocomplete
    public static string Load_Tags_AutoComplete(string term)
    {
        SqlConnection con = new SqlConnection(Config.ConnectionString);
        if (con.State != ConnectionState.Open) con.Open();
        List<Tags_Struct> _items = new List<Tags_Struct>();
        Tags_Struct _item;

        // generate sql query
        string query = "";
        // Mysql compatible
        //query = "SELECT Distinct tagname from tags where status=1 AND tagname like @term ORDER BY records DESC LIMIT 10";
        // SQL SERVER compatible
        query = "SELECT Distinct TOP 10 tagname,records from tags where status=1 AND tagname like @term ORDER BY records DESC";
        // execute sql query
        SqlCommand video_cmd = new SqlCommand(query, con);
        video_cmd.Parameters.Add(new SqlParameter("@term", term + '%'));
        SqlDataReader reader = video_cmd.ExecuteReader(CommandBehavior.CloseConnection);
        
        StringBuilder suggestions = new StringBuilder();
        StringBuilder data = new StringBuilder();
        int counter = 0;
        suggestions.Append("suggestions:[");
        data.Append("data:[");
        while (reader.Read())
        {
            if (counter == 0)
            {
                //suggestions.Append("'" + reader["tagname"] + " - " + reader["records"] + " records'");
                suggestions.Append("'" + reader["tagname"] + "'");
                data.Append("'" + reader["tagname"] + "'");
            }
            else
            {
                // suggestions.Append(",'" + reader["tagname"] + " - " + reader["records"] + " records'");
                suggestions.Append(",'" + reader["tagname"] + "'");
                data.Append(",'" + reader["tagname"] + "'");
            }
            counter = counter + 1;
        }
        reader.Close();
        con.Close(); con.Dispose();
        suggestions.Append("]");
        data.Append("]");

        StringBuilder jsonoutput = new StringBuilder();
        jsonoutput.Append("{query:'" + term + "'," + suggestions.ToString() + "," + data.ToString() + "}");

        return jsonoutput.ToString();
    }

    
    // Fetch tags for internal content processing
    public static List<Tags_Struct> Fetch_Content_Tags(int type)
    {
        SqlConnection con = new SqlConnection(Config.ConnectionString);
        if (con.State != ConnectionState.Open) con.Open();
        List<Tags_Struct> _items = new List<Tags_Struct>();
        Tags_Struct _item;

        // generate sql query
        StringBuilder str = new StringBuilder();
        str.Append("SELECT tagname from tags where status=1 AND tag_type=0 AND type=@type ORDER BY tagid desc");

        // execute sql query
        SqlCommand video_cmd = new SqlCommand(str.ToString(), con);
        video_cmd.Parameters.Add(new SqlParameter("@type", type));
        SqlDataReader reader = video_cmd.ExecuteReader(CommandBehavior.CloseConnection);
        while (reader.Read())
        {
            _item = new Tags_Struct();
            _item.TagName = reader["tagname"].ToString();
            _items.Add(_item);
        }
        reader.Close();
        con.Close(); con.Dispose();

        return _items;
    }

}
