﻿using System;
using System.Data;

using System.Data.SqlClient;
using System.Configuration;
using System.Web;
using System.Web.UI;
using System.Text;

/// <summary>
/// This class handles RSS and Sitemaps
/// </summary>
public class XMLBLL
{
   
    public XMLBLL()
    {
        //
        // TODO: Add constructor logic here
        //
    }

    // Create video url sitemap
    // Create member url sitemap
    // Create category url sitemap
    
    public static string BuildGoogleSiteMap_VideoUrls()
    {
        StringBuilder str = new StringBuilder();
        str.Append("<urlset xmlns=\"http://www.sitemaps.org/schemas/sitemap/0.9\" xmlns:xsi=\"http://www.w3.org/2001/XMLSchema-instance\"  xsi:schemaLocation=\"http://www.sitemaps.org/schemas/sitemap/0.9 http://www.sitemaps.org/schemas/sitemap/0.9/sitemap.xsd\">");
        // start sitemap url
        SqlConnection con = new SqlConnection(Config.ConnectionString);
        if (con.State != ConnectionState.Open) con.Open();
        string Query = "SELECT  TOP 50000 VideoID,title FROM videos WHERE isEnabled=1 AND isPrivate=0 AND ispublished=1 AND isreviewed=1";
        SqlCommand cmd= new SqlCommand(Query, con);
        SqlDataReader reader = cmd.ExecuteReader(CommandBehavior.CloseConnection);
        while(reader.Read())
        {
            str.Append("<url>");
            str.Append("<loc>" + UrlConfig.Prepare_Video_Preview_Url((long)reader["VideoID"],reader["title"].ToString(),false) + "</loc>");
            str.Append("<priority>0.80</priority>");
            str.Append("<lastmod>" + string.Format("{0:s}", DateTime.Now) + "+00:00</lastmod>");
            str.Append("<changefreq>daily</changefreq>");
            str.Append("</url>");
        }
        // close sitemap url
        str.Append("</urlset>");

        return str.ToString();
    }

    public static string BuildGoogleSiteMap_VideoUrls(int type,int pagenumber)
    {
        StringBuilder str = new StringBuilder();
        str.Append("<urlset xmlns=\"http://www.sitemaps.org/schemas/sitemap/0.9\" xmlns:xsi=\"http://www.w3.org/2001/XMLSchema-instance\"  xsi:schemaLocation=\"http://www.sitemaps.org/schemas/sitemap/0.9 http://www.sitemaps.org/schemas/sitemap/0.9/sitemap.xsd\">");
        // start sitemap url
        SqlConnection con = new SqlConnection(Config.ConnectionString);
        if (con.State != ConnectionState.Open) con.Open();
        StringBuilder qr = new StringBuilder();
        string query = "VideoID,title FROM videos WHERE isEnabled=1 AND isPrivate=0 AND ispublished=1 AND isreviewed=1";
        string _order = "videoid asc";
        //if (type == 1)
        //    _order = "views desc, liked desc";
        //else if (type == 2)
        //    _order = "liked desc,views desc";
        //else
        //    _order = "videoid desc";

        switch (Config.Return_PaginationType())
        {
            case 0:
                // SQL SERVER 2005 or Later Supported Query
                qr.Append(Pagination_Process.Prepare_SQLSERVER2005_Pagination(query.ToString(), _order, pagenumber, 50000));
                break;
            case 1:
                // MySQL Supported Query
                string mysql_query = "SELECT " + query.ToString() + " ORDER BY " + _order;
                qr.Append(Pagination_Process.Prepare_MySQL_Pagination(mysql_query, pagenumber, 50000));
                break;
            case 2:
                // SQL SERVER 2000 Supported Query
                string normal_query = "SELECT TOP 50000 " + query.ToString() + " ORDER BY " + _order;
                qr.Append(normal_query);
                break;
        }
        SqlCommand cmd = new SqlCommand(qr.ToString(), con);
        SqlDataReader reader = cmd.ExecuteReader(CommandBehavior.CloseConnection);
        while (reader.Read())
        {
            str.Append("<url>");
            str.Append("<loc>" + UrlConfig.Prepare_Video_Preview_Url((long)reader["VideoID"], reader["title"].ToString(), false) + "</loc>");
            //str.Append("<priority>0.80</priority>");
            //str.Append("<lastmod>" + string.Format("{0:s}", DateTime.Now) + "+00:00</lastmod>");
            //str.Append("<changefreq>daily</changefreq>");
            str.Append("</url>");
        }
        // close sitemap url
        str.Append("</urlset>");

        return str.ToString();
    }

    public static string BuildGoogleSiteMap_VideoUrls(int categoryid,int type,int pagenumber)
    {
        StringBuilder str = new StringBuilder();
        str.Append("<urlset xmlns=\"http://www.sitemaps.org/schemas/sitemap/0.9\" xmlns:xsi=\"http://www.w3.org/2001/XMLSchema-instance\"  xsi:schemaLocation=\"http://www.sitemaps.org/schemas/sitemap/0.9 http://www.sitemaps.org/schemas/sitemap/0.9/sitemap.xsd\">");
        // start sitemap url
        SqlConnection con = new SqlConnection(Config.ConnectionString);
        if (con.State != ConnectionState.Open) con.Open();
        StringBuilder qr = new StringBuilder();
        string query = "VideoID,title FROM videos WHERE isEnabled=1 AND isPrivate=0 AND ispublished=1 AND isreviewed=1 AND categoryid=" + categoryid + "";
        string _order = "views desc, liked desc";
        if (type == 1)
            _order = "views desc, liked desc";
        else if (type == 2)
            _order = "liked desc,views desc";
        else
            _order = "videoid desc";

        switch (Config.Return_PaginationType())
        {
            case 0:
                // SQL SERVER 2005 or Later Supported Query
                qr.Append(Pagination_Process.Prepare_SQLSERVER2005_Pagination(query.ToString(), _order, pagenumber, 50000));
                break;
            case 1:
                // MySQL Supported Query
                string mysql_query = "SELECT " + query.ToString() + " ORDER BY " + _order;
                qr.Append(Pagination_Process.Prepare_MySQL_Pagination(mysql_query, pagenumber, 50000));
                break;
            case 2:
                // SQL SERVER 2000 Supported Query
                string normal_query = "SELECT TOP 50000 " + query.ToString() + " ORDER BY " + _order;
                qr.Append(normal_query);
                break;
        }
        SqlCommand cmd = new SqlCommand(qr.ToString(), con);
        SqlDataReader reader = cmd.ExecuteReader(CommandBehavior.CloseConnection);
        while (reader.Read())
        {
            str.Append("<url>");
            str.Append("<loc>" + UrlConfig.Prepare_Video_Preview_Url((long)reader["VideoID"], reader["title"].ToString(), false) + "</loc>");
            //str.Append("<priority>0.80</priority>");
            //str.Append("<lastmod>" + string.Format("{0:s}", DateTime.Now) + "+00:00</lastmod>");
            //str.Append("<changefreq>daily</changefreq>");
            str.Append("</url>");
        }
        // close sitemap url
        str.Append("</urlset>");

        return str.ToString();
    }

 
    // Generate Category Url - Google Submission
    public static string BuildGoogleSiteMap_CategoryUrls(int type)
    {
        StringBuilder str = new StringBuilder();
        str.Append("<urlset xmlns=\"http://www.sitemaps.org/schemas/sitemap/0.9\" xmlns:xsi=\"http://www.w3.org/2001/XMLSchema-instance\"  xsi:schemaLocation=\"http://www.sitemaps.org/schemas/sitemap/0.9 http://www.sitemaps.org/schemas/sitemap/0.9/sitemap.xsd\">");
        // start sitemap url
        SqlConnection con = new SqlConnection(Config.ConnectionString);
        if (con.State != ConnectionState.Open) con.Open();
        string Query = "SELECT categoryid,categoryname,term FROM categories WHERE type=" + type + " order by categoryid desc";
        SqlCommand cmd = new SqlCommand(Query, con);
        SqlDataReader reader = cmd.ExecuteReader(CommandBehavior.CloseConnection);
        while (reader.Read())
        {
            str.Append("<url>");
            string url = UrlConfig.Prepare_Category_Url(Convert.ToInt32(reader["categoryid"]), reader["categoryname"].ToString(), reader["term"].ToString(), type, true);
            str.Append("<loc>" + url + "</loc>");
            str.Append("<priority>0.90</priority>");
          //  str.Append("<lastmod>" + string.Format("{0:s}", DateTime.Now) + "+00:00</lastmod>");
          //  str.Append("<changefreq>daily</changefreq>");
            str.Append("</url>");
        }
        // close sitemap url
        str.Append("</urlset>");

        return str.ToString();
    }
        

    // Generate Tags Url - Google Submission
    public static string BuildGoogleSiteMap_TagsUrls(int type,int pagenumber)
    {
        StringBuilder str = new StringBuilder();
        str.Append("<urlset xmlns=\"http://www.sitemaps.org/schemas/sitemap/0.9\" xmlns:xsi=\"http://www.w3.org/2001/XMLSchema-instance\"  xsi:schemaLocation=\"http://www.sitemaps.org/schemas/sitemap/0.9 http://www.sitemaps.org/schemas/sitemap/0.9/sitemap.xsd\">");
        // start sitemap url
        SqlConnection con = new SqlConnection(Config.ConnectionString);
        if (con.State != ConnectionState.Open) con.Open();
        StringBuilder qr = new StringBuilder();
        int tagtype = type;
        if (tagtype == 0)
            tagtype = 2;
        string query = "tagname FROM tags WHERE type=" + tagtype + " AND status=1";
        switch (Config.Return_PaginationType())
        {
            case 0:
                // SQL SERVER 2005 or Later Supported Query
                qr.Append(Pagination_Process.Prepare_SQLSERVER2005_Pagination(query.ToString(), "tagid desc", pagenumber, 50000));
                break;
            case 1:
                // MySQL Supported Query
                string mysql_query = "SELECT " + query.ToString() + " ORDER BY records desc";
                qr.Append(Pagination_Process.Prepare_MySQL_Pagination(mysql_query, pagenumber, 50000));
                break;
            case 2:
                // SQL SERVER 2000 Supported Query
                string normal_query = "SELECT TOP 50000 " + query.ToString() + " ORDER BY tagid desc";
                qr.Append(normal_query);
                break;
        }
        SqlCommand cmd = new SqlCommand(qr.ToString(), con);
        SqlDataReader reader = cmd.ExecuteReader(CommandBehavior.CloseConnection);
        while (reader.Read())
        {
            str.Append("<url>");
            string url = UrlConfig.Prepare_Tag_Url(reader["tagname"].ToString(),type,true);
            str.Append("<loc>" + url + "</loc>");
            //str.Append("<priority>0.70</priority>");
           // str.Append("<lastmod>" + string.Format("{0:s}", DateTime.Now) + "+00:00</lastmod>");
            //str.Append("<changefreq>daily</changefreq>");
            str.Append("</url>");
        }
        // close sitemap url
        str.Append("</urlset>");

        return str.ToString();
    }


   
    // Video Sitemap Generator Script
    public static string BuildGoogleVideoSiteMap()
    {
        StringBuilder str = new StringBuilder();
        str.Append("<urlset xmlns=\"http://www.sitemaps.org/schemas/sitemap/0.9\" xmlns:video=\"http://www.google.com/schemas/sitemap-video/1.1\">");
        // start sitemap url
        SqlConnection con = new SqlConnection(Config.ConnectionString);
        if (con.State != ConnectionState.Open) con.Open();
        string Query = "SELECT VideoID,title,username,description,tags,duration_sec,views,avg_rating,videofilename,thumbfilename,flv_url,thumb_url,Date_Added FROM videos WHERE isEnabled=1 AND isPrivate=0 AND ispublished=1 AND isreviewed=1";
        SqlCommand cmd = new SqlCommand(Query, con);
        SqlDataReader reader = cmd.ExecuteReader(CommandBehavior.CloseConnection);
        while (reader.Read())
        {
            string VideoPath = Config.Return_FLV_Video_Url(reader["flv_url"].ToString(),reader["username"].ToString()) + "/" + reader["videofilename"].ToString();
            string ThumbPath = Config.Return_Video_Thumb_Url(reader["thumb_url"].ToString(),reader["username"].ToString()) + "/" + reader["thumbfilename"].ToString();
            string Url = UrlConfig.Prepare_Video_Preview_Url((long)reader["VideoID"], reader["title"].ToString(), false);
            str.Append("<url>");
            str.Append("<loc>" + Url + "</loc>");
            str.Append("<video:video>");
            str.Append("<video:content_loc>" + VideoPath + "</video:content_loc>");
            str.Append("<video:player_loc allow_embed=\"yes\">" + Config.Return_Player_Url() + "</video:player_loc>");
            str.Append("<video:thumbnail_loc>" + ThumbPath + "</video:thumbnail_loc>");
            str.Append("<video:title>" + reader["title"].ToString() + "</video:title>");
            str.Append("<video:description>" + reader["description"].ToString() + "</video:description>");
            str.Append("<video:rating>" + reader["avg_rating"].ToString() + "</video:rating>");
            str.Append("<video:view_count>" + reader["views"].ToString() + "</video:view_count>");
            str.Append("<video:publication_date>" + string.Format("{0:s}",reader["date_added"].ToString()) + "</video:publication_date>");
            string tags = reader["tags"].ToString();
            if (tags != "")
            {
               string[] arr;
                arr = tags.ToString().Split(char.Parse(" "));
                int i = 0;
                for (i = 0; i <= arr.Length - 1; i++)
                {
                    if(arr[i].Length>2)
                        str.Append("<video:tag>" + arr[i].ToString() + "</video:tag>");
                } 
            }
           // str.Append("<video:category>Grilling</video:category>");
            str.Append("<video:family_friendly>yes</video:family_friendly>");
            str.Append("<video:duration>" + reader["duration_sec"].ToString() + "</video:duration>");
            str.Append("</video:video>");
            str.Append("</url>");
         
        }

       

        // close sitemap url
        str.Append("</urlset>");

        return str.ToString();
    }

   

    //************************************************************************
    // Yahoo Sitemap submission
    //************************************************************************

    public static string BuildYahooSiteMap_VideoUrls(int type, int pagenumber)
    {
        StringBuilder str = new StringBuilder();
        str.Append("<@xml version=\"1.0\" encoding=\"UTF-8\"@>");
        str.Append("<rss version=\"2.0\" xmlns:ror=\"http://rorweb.com/0.1/\" >");

        str.Append("<channel>");
        str.Append("<title>" + Site_Settings.Page_Caption + "</title>");
        str.Append("<link>" + Config.GetUrl() + "</link>");
        // start sitemap url
        SqlConnection con = new SqlConnection(Config.ConnectionString);
        if (con.State != ConnectionState.Open) con.Open();
        StringBuilder qr = new StringBuilder();
        string query = "VideoID,title FROM videos WHERE isEnabled=1 AND isPrivate=0 AND ispublished=1 AND isreviewed=1";
        string _order = "videoid asc";
        //if (type == 1)
        //    _order = "views desc, liked desc";
        //else if (type == 2)
        //    _order = "liked desc,views desc";
        //else
        //    _order = "videoid desc";

        switch (Config.Return_PaginationType())
        {
            case 0:
                // SQL SERVER 2005 or Later Supported Query
                qr.Append(Pagination_Process.Prepare_SQLSERVER2005_Pagination(query.ToString(), _order, pagenumber, 50000));
                break;
            case 1:
                // MySQL Supported Query
                string mysql_query = "SELECT " + query.ToString() + " ORDER BY " + _order;
                qr.Append(Pagination_Process.Prepare_MySQL_Pagination(mysql_query, pagenumber, 50000));
                break;
            case 2:
                // SQL SERVER 2000 Supported Query
                string normal_query = "SELECT TOP 50000 " + query.ToString() + " ORDER BY " + _order;
                qr.Append(normal_query);
                break;
        }
        SqlCommand cmd = new SqlCommand(qr.ToString(), con);
        SqlDataReader reader = cmd.ExecuteReader(CommandBehavior.CloseConnection);
        while (reader.Read())
        {
            str.Append("<item>");
            str.Append("<link>" + UrlConfig.Prepare_Video_Preview_Url((long)reader["VideoID"], reader["title"].ToString(), false) + "</link>");
            str.Append("<ror:updatePeriod></ror:updatePeriod>");
            str.Append("<ror:sortOrder>1</ror:sortOrder>");
            str.Append("<ror:resourceOf>sitemap</ror:resourceOf> ");
            str.Append("</item>");
        }
       
        // close sitemap url
        str.Append("</channel>");
        str.Append("</rss>");

        return str.ToString();
    }
    // Generate Category Url - Google Submission
    public static string BuildYahooSiteMap_CategoryUrls(int type)
    {
        StringBuilder str = new StringBuilder();
        str.Append("<@xml version=\"1.0\" encoding=\"UTF-8\"@>");
        str.Append("<rss version=\"2.0\" xmlns:ror=\"http://rorweb.com/0.1/\" >");

        str.Append("<channel>");
        str.Append("<title>" + Site_Settings.Page_Caption + "</title>");
        str.Append("<link>" + Config.GetUrl() + "</link>");
        // start sitemap url
        // start sitemap url
        SqlConnection con = new SqlConnection(Config.ConnectionString);
        if (con.State != ConnectionState.Open) con.Open();
        string Query = "SELECT categoryid,categoryname,term FROM categories WHERE type=" + type + " order by categoryid desc";
        SqlCommand cmd = new SqlCommand(Query, con);
        SqlDataReader reader = cmd.ExecuteReader(CommandBehavior.CloseConnection);
        while (reader.Read())
        {
            str.Append("<item>");
            string category_path = "c/";
            switch (type)
            {
                case 0:
                    category_path = "c/";
                    break;
                case 1:
                    category_path = "groups/category/";
                    break;
                case 5:
                    category_path = "photos/category/";
                    break;
                case 6:
                    category_path = "blogs/category/";
                    break;
            }
            string url = UrlConfig.Prepare_Category_Url(Convert.ToInt32(reader["categoryid"]), reader["categoryname"].ToString(), reader["term"].ToString(), type, true);
            str.Append("<link>" + url + "</link>");
            str.Append("<ror:updatePeriod></ror:updatePeriod>");
            str.Append("<ror:sortOrder>1</ror:sortOrder>");
            str.Append("<ror:resourceOf>sitemap</ror:resourceOf> ");
            str.Append("</item>");
        }
        // close sitemap url
        str.Append("</channel>");
        str.Append("</rss>");

        return str.ToString();

    }

    // Generate Tags Url - Yahoo Submission
    public static string BuildYahooSiteMap_TagUrls(int type, int pagenumber)
    {
        StringBuilder str = new StringBuilder();
        str.Append("<@xml version=\"1.0\" encoding=\"UTF-8\"@>");
        str.Append("<rss version=\"2.0\" xmlns:ror=\"http://rorweb.com/0.1/\" >");

        str.Append("<channel>");
        str.Append("<title>" + Site_Settings.Page_Caption + "</title>");
        str.Append("<link>" + Config.GetUrl() + "</link>");
        // start sitemap url
        StringBuilder qr = new StringBuilder();
        SqlConnection con = new SqlConnection(Config.ConnectionString);
        if (con.State != ConnectionState.Open) con.Open();
        int tagtype = type;
        if (tagtype == 0)
            tagtype = 2;
        string query = "tagname FROM tags WHERE type=" + tagtype + " AND status=1";
        switch (Config.Return_PaginationType())
        {
            case 0:
                // SQL SERVER 2005 or Later Supported Query
                qr.Append(Pagination_Process.Prepare_SQLSERVER2005_Pagination(query.ToString(), "tagid desc", pagenumber, 50000));
                break;
            case 1:
                // MySQL Supported Query
                string mysql_query = "SELECT " + query.ToString() + " ORDER BY records desc";
                qr.Append(Pagination_Process.Prepare_MySQL_Pagination(mysql_query, pagenumber, 50000));
                break;
            case 2:
                // SQL SERVER 2000 Supported Query
                string normal_query = "SELECT TOP 50000 " + query.ToString() + " ORDER BY tagid desc";
                qr.Append(normal_query);
                break;
        }
        SqlCommand cmd = new SqlCommand(qr.ToString(), con);
        SqlDataReader reader = cmd.ExecuteReader(CommandBehavior.CloseConnection);
        while (reader.Read())
        {
            string url = UrlConfig.Prepare_Tag_Url(reader["tagname"].ToString(), type,true);
            str.Append("<item>");
            str.Append("<link>" + url + "</link>");
            str.Append("<ror:updatePeriod></ror:updatePeriod>");
            str.Append("<ror:sortOrder>2</ror:sortOrder>");
            str.Append("<ror:resourceOf>sitemap</ror:resourceOf> ");
            str.Append("</item>");
        }

        // close sitemap url
        str.Append("</channel>");
        str.Append("</rss>");

        return str.ToString();
    }

}
