﻿using System;
using System.Collections;
using System.Configuration;
using System.Data;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.HtmlControls;
using System.Web.UI.WebControls;

using System.Collections.Generic;

public partial class adm_sc_modules_video_video_snap : System.Web.UI.UserControl
{
    public long VideoID
    {
        get
        {
            if (ViewState["VideoID"] != null)
                return (long)ViewState["VideoID"];
            else
                return 0;
        }
        set
        {
            ViewState["VideoID"] = value;
        }
    }

    public DateTime Date_Added
    {
        get
        {
            if (ViewState["Date_Added"] != null)
                return (DateTime)ViewState["Date_Added"];
            else
                return DateTime.Now;
        }
        set
        {
            ViewState["Date_Added"] = value;
        }
    }

    public string UserName
    {
        get
        {
            if (ViewState["UserName"] != null)
                return ViewState["UserName"].ToString();
            else
                return "";
        }
        set
        {
            ViewState["UserName"] = value;
        }
    }

    public string Categories
    {
        get
        {
            if (ViewState["Categories"] != null)
                return ViewState["Categories"].ToString();
            else
                return "";
        }
        set
        {
            ViewState["Categories"] = value;
        }
    }

    public string Title
    {
        get
        {
            if (ViewState["Title"] != null)
                return ViewState["Title"].ToString();
            else
                return "";
        }
        set
        {
            ViewState["Title"] = value;
        }
    }

    public string Description
    {
        get
        {
            if (ViewState["Description"] != null)
                return ViewState["Description"].ToString();
            else
                return "";
        }
        set
        {
            ViewState["Description"] = value;
        }
    }

    public string Tags
    {
        get
        {
            if (ViewState["Tags"] != null)
                return ViewState["Tags"].ToString();
            else
                return "";
        }
        set
        {
            ViewState["Tags"] = value;
        }
    }

    public int CategoryID
    {
        get
        {
            if (ViewState["CategoryID"] != null)
                return (int)ViewState["CategoryID"];
            else
                return 0;
        }
        set
        {
            ViewState["CategoryID"] = value;
        }
    }

    public int Views
    {
        get
        {
            if (ViewState["Views"] != null)
                return (int)ViewState["Views"];
            else
                return 0;
        }
        set
        {
            ViewState["Views"] = value;
        }
    }

    public int Downloads
    {
        get
        {
            if (ViewState["Downloads"] != null)
                return (int)ViewState["Downloads"];
            else
                return 0;
        }
        set
        {
            ViewState["Downloads"] = value;
        }
    }
    
    public int Comments
    {
        get
        {
            if (ViewState["Comments"] != null)
                return (int)ViewState["Comments"];
            else
                return 0;
        }
        set
        {
            ViewState["Comments"] = value;
        }
    }

    public int Favorited
    {
        get
        {
            if (ViewState["Favorited"] != null)
                return (int)ViewState["Favorited"];
            else
                return 0;
        }
        set
        {
            ViewState["Favorited"] = value;
        }
    }

    public int Type
    {
        get
        {
            if (ViewState["Type"] != null)
                return (int)ViewState["Type"];
            else
                return 0;
        }
        set
        {
            ViewState["Type"] = value;
        }
    }

    public int Liked
    {
        get
        {
            if (ViewState["Liked"] != null)
                return (int)ViewState["Liked"];
            else
                return 0;
        }
        set
        {
            ViewState["Liked"] = value;
        }
    }

    public int Disliked
    {
        get
        {
            if (ViewState["Disliked"] != null)
                return (int)ViewState["Disliked"];
            else
                return 0;
        }
        set
        {
            ViewState["Disliked"] = value;
        }
    }

    public int isEnabled
    {
        get
        {
            if (ViewState["isEnabled"] != null)
                return (int)ViewState["isEnabled"];
            else
                return 1;
        }
        set
        {
            ViewState["isEnabled"] = value;
        }
    }

    public int isApproved
    {
        get
        {
            if (ViewState["isApproved"] != null)
                return (int)ViewState["isApproved"];
            else
                return 1;
        }
        set
        {
            ViewState["isApproved"] = value;
        }
    }

    public int isFeatured
    {
        get
        {
            if (ViewState["isFeatured"] != null)
                return (int)ViewState["isFeatured"];
            else
                return 1;
        }
        set
        {
            ViewState["isFeatured"] = value;
        }
    }

    public int isAdult
    {
        get
        {
            if (ViewState["isAdult"] != null)
                return (int)ViewState["isAdult"];
            else
                return 0;
        }
        set
        {
            ViewState["isAdult"] = value;
        }
    }

    protected void Page_Load(object sender, EventArgs e)
    {
        HideMessage();
        if (!Page.IsPostBack)
        {
            // load parent / child categories
            int category_type = 0; // represent videos
            if (this.Type == 1)
                category_type = 7; // represent audio
            if (Site_Settings.AllowMultipleCategoryListing)
            {
                // Multiple category selection is on
                CategoriesBLL.BindCategories(l_category, 0, category_type, " " + Resources.vsk.selectcategory + " ", " ", false);
                scat.Visible = false;
            }
            else
            {
                // Single category selection is on
                // load parent / child categories
                CategoriesBLL.BindCategories(drp_category, 0, category_type, " " + Resources.vsk.selectcategory + " ", " ", false);
                mcat.Visible = false;
            }

            // set video information
            lbl_added.Text = string.Format("{0:D}", this.Date_Added);
            lnk_username.Text = this.UserName;
            lnk_username.NavigateUrl = UrlConfig.Prepare_User_Profile_Url(this.UserName, true);
            txt_title.Text = this.Title;
            txt_description.Text = UtilityBLL.DeCompressCodeBreak(this.Description);
            txt_tags.Text = this.Tags;
            drp_category.SelectedValue = this.CategoryID.ToString();

            txt_views.Text = this.Views.ToString();
            txt_liked.Text = this.Liked.ToString();
            txt_disliked.Text = this.Disliked.ToString();
            txt_downloads.Text = this.Downloads.ToString();
            if (this.isEnabled == 1)
            {
                lbl_enabled.Text = "Yes";
                lbl_enabled.CssClass = "mini-text green bold";
            }
            else
            {
                lbl_enabled.Text = "No";
                lbl_enabled.CssClass = "mini-text red bold";
            }
            if (this.isApproved == 1)
            {
                lbl_approved.Text = "Yes";
                lbl_approved.CssClass = "mini-text green bold";
            }
            else
            {
                lbl_approved.Text = "No";
                lbl_approved.CssClass = "mini-text red bold";
            }
            if (this.isFeatured == 1)
            {
                lbl_featured.Text = "Yes";
                lbl_featured.CssClass = "mini-text green bold";
            }
            else
            {
                lbl_featured.Text = "No";
                lbl_featured.CssClass = "mini-text red bold";
            }
            if (this.isAdult == 1)
            {
                lbl_adult.Text = "Yes";
                lbl_adult.CssClass = "mini-text red bold";
            }
            else
            {
                lbl_adult.Text = "No";
                lbl_adult.CssClass = "mini-text green bold";
            }

            lbl_comments.Text = this.Comments.ToString();
            if (this.Comments > 0)
            {
                lnk_cmt.Visible = true;
                lnk_cmt.NavigateUrl = Config.GetUrl() + "adm/sc/comments/Default.aspx?id=" + this.VideoID + "&type=0&cmts=" + this.Comments;
                lnk_cmt.Text = "View All Comments";
            }
            else
            {
                lnk_cmt.Visible = false;
            }
            lbl_favorited.Text = this.Favorited.ToString();

            if (Site_Settings.Feature_Categories == 1)
            {
                if (Site_Settings.AllowMultipleCategoryListing)
                {
                    // multile categories
                    UGeneral.SelectMultipleItems(l_category, this.Categories);
                }
                else
                {
                    // single category
                    drp_category.SelectedValue = this.Categories.ToString();
                }
            }
        }
    }
       

    
    protected void btn_add_Click(object sender, EventArgs e)
    {
        if (!Config.isAdminActionAllowed())
        {
            Response.Redirect( Config.GetUrl("adm/sc/Default.aspx?action_error=true"));
            return;
        }
        if (this.VideoID > 0)
        {
            Video_Struct vd = new Video_Struct();
            vd.Title = txt_title.Text;
            vd.Description = txt_description.Text;
            vd.Tags = txt_tags.Text;
            vd.VideoID = this.VideoID;
            string _categories = "";
            // categories enabled
            if (Site_Settings.AllowMultipleCategoryListing)
            {
                _categories = UGeneral.ReturnSelectedCategories(l_category);
                if (_categories == "")
                {
                    //Config.ShowMessageV2(msg, Resources.vsk.selectatleastonecategory, 0, 0);
                    return;
                }
            }
            else
            {
                _categories = drp_category.SelectedValue;
            }
            vd.Liked = Convert.ToInt32(txt_liked.Text);
            vd.Disliked = Convert.ToInt32( txt_disliked.Text);
            vd.Views =  Convert.ToInt32(txt_views.Text);
            vd.Downloads = Convert.ToInt32(txt_downloads.Text);
            vd.CategoryID = 0;
            vd.Categories = _categories;
            VideoBLL.Update_VideoInfo_Adm(vd);

            Response.Redirect(Config.GetUrl("adm/sc/videos/videodetail.aspx?vid=" + this.VideoID + "&status=updated"),true);
            ShowMessage("Video information updated successfully");
        }
    }
    protected void btn_current_Click(object sender, EventArgs e)
    {
        if (!Config.isAdminActionAllowed())
        {
            Response.Redirect( Config.GetUrl("adm/sc/Default.aspx?action_error=true"));
            return;
        }
        if (this.VideoID > 0)
        {
            VideoBLL.Update_Field(VideoID, DateTime.Now, "date_added");

            ShowMessage("Video published date updated");
            lbl_added.Text = string.Format("{0:D}", DateTime.Now);
        }
    }

    private void ShowMessage(string message)
    {
        pnl_error.Visible = true;
        lbl_error.Text = message;
    }

    private void HideMessage()
    {
        pnl_error.Visible = false;
        lbl_error.Text = "";
    }
}
