﻿using System;
using System.Collections;
using System.Configuration;
using System.Data;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.HtmlControls;
using System.Web.UI.WebControls;

using System.Collections.Generic;
using System.Text;

public partial class myaccount_modules_myvideos_v1 : System.Web.UI.UserControl
{
    protected string _script = "";
    public int MediaType = 0;

  
    public int PageNumber
    {
        get
        {
            if (ViewState["PageNumber"] != null)
                return (int)ViewState["PageNumber"];
            else
                return 1;
        }
        set
        {
            ViewState["PageNumber"] = value;
        }
    }

    public int PageSize
    {
        get
        {
            if (ViewState["PageSize"] != null)
                return (int)ViewState["PageSize"];
            else
                return 20;
        }
        set
        {
            ViewState["PageSize"] = value;
        }
    }

    public string UserName
    {
        get
        {
            if (ViewState["UserName"] != null)
                return ViewState["UserName"].ToString();
            else
                return "";
        }
        set
        {
            ViewState["UserName"] = value;
        }
    }

    public string ThumbRoTator
    {
        get
        {
            if (ViewState["ThumbRoTator"] != null)
                return ViewState["ThumbRoTator"].ToString();
            else
                return "";
        }
        set
        {
            ViewState["ThumbRoTator"] = value;
        }
    }

    public int Total_Records
    {
        get
        {
            if (ViewState["Total_Records"] != null)
                return (int)ViewState["Total_Records"];
            else
                return 0; // hust added videos
        }
        set
        {
            ViewState["Total_Records"] = value;
        }
    }

    public bool LoadFavorites
    {
        get
        {
            if (ViewState["LoadFavorites"] != null)
                return (bool)ViewState["LoadFavorites"];
            else
                return false;
        }
        set
        {
            ViewState["LoadFavorites"] = value;
        }
    }

    public bool LoadLiked
    {
        get
        {
            if (ViewState["LoadLiked"] != null)
                return (bool)ViewState["LoadLiked"];
            else
                return false;
        }
        set
        {
            ViewState["LoadLiked"] = value;
        }
    }

    protected override void OnInit(EventArgs e)
    {
        base.OnInit(e);
        rptPages.ItemCommand += this.rptPages_ItemCommand;

    }

    protected void Page_Load(object sender, EventArgs e)
    {
        // Globalization Text
        btn_bsave.Text = Resources.vsk.delete; // Delete
        btn_delete.Text = Resources.vsk.delete; //Delete
        if (!Page.IsPostBack)
        {           
           
            // load videos
            BindList();
        }
    }


    private void BindList()
    {
        // setup active sorting navigation
        Setup_Video_Navigation();

        LoadSettings();

        string order = "date_added desc, liked desc, views desc";

        if (Request.Params["o"] != null)
        {
            switch (Request.Params["o"].ToString())
            {
                case "0":
                    // title
                    order = "title asc, liked desc, views desc, date_added desc";
                    break;
                case "1":
                    // time
                    order = "duration_sec desc, liked desc, views desc";
                    break;
                case "2":
                    // date
                    order = "date_added desc, liked desc, views desc";
                    break;
                case "3":
                    // views
                    order = "views desc, liked desc, date_added desc";
                    break;
                case "4":
                    // rating
                    order = "liked desc, views desc, date_added desc";
                    break;
            }
        }

        string search = "";
        if (Request.Params["query"] != null)
            search = Server.UrlDecode(Request.Params["query"].ToString());

        int ispublishedvideos = 2; // load published and unpublished videos both
        // query
        Video_Struct query = new Video_Struct();
        query.Term = search;
        query.isFeatured = 2;
        query.Type = this.MediaType;
        query.UserName = this.UserName;
        query.Month = 0;
        query.Year = 0;
        query.Filter = 0;
        query.isEnabled = 2;
        query.isReviewed = 2;
        query.isPrivate = 3;
        query.isAdult = 2;
        query.isExternal = 3;
        query.Order = "date_added desc";
        query.PageSize = this.PageSize;
        query.SearchType = 3;
        query.DateFilter = 0;
        query.isCache = false;
        query.Mode = 0;
        query.GalleryID = 0;
        query.PageNumber = this.PageNumber;
        query.isPublished = ispublishedvideos;
        query.LoadLiked = this.LoadLiked;
        query.LoadFavorites = this.LoadFavorites;

        VideoBLL vbll = new VideoBLL();


        this.Total_Records = vbll.Count_Videos_V4(query);
        if (this.Total_Records == 0)
        {
            main.Visible = false;
            norecord.Visible = true;
            return;
        }
        List<Video_Struct> _list = vbll.Fetch_Videos_V4(query);
        if (_list.Count > 0)
        {
           this.ThumbRoTator = "";
           if (Config.Return_PaginationType() == 2)
           {
               // SQL Server Pagination
               this.Total_Records = _list.Count;
           }
           Pagination_Process.Process_Pagination(MyList, rptPages, lnk_Prev, lnk_Next, this.PageSize, this.PageNumber, _list, this.Total_Records);
      
            main.Visible = true;
            norecord.Visible = false;
            _script = "<script type=\"text/javascript\">" + this.ThumbRoTator + "</script>";

        }
        else
        {
            main.Visible = false;
            norecord.Visible = true;
         
        }
    }


    protected void MyList_ItemDataBound(object sender, DataListItemEventArgs e)
    {
        if (e.Item.ItemType == ListItemType.Item || e.Item.ItemType == ListItemType.AlternatingItem)
        {
            modules_item_videoitem item = (modules_item_videoitem)e.Item.FindControl("Videoitem1");
            item.VD = (Video_Struct)e.Item.DataItem;
            item.MediaType = this.MediaType;
            if (LoadFavorites || LoadLiked)
            {
                // liked or favorited videos or audio files
                item.ShowTitle =true;
                item.ShowDate =true;
                item.ShowUser =true;
            }
            else
            {
                // my own videos
                item.ShowDisabled=true;
                item.ShowApproved=true;
                item.ShowDate=true;
                item.ShowUser=false;
                item.ContentLayout=1;
                item.BoxWidth=500;
                item.LeftWidth=30;
                item.RightWidth=69;
            }
            long VideoID = Convert.ToInt64(((Label)e.Item.FindControl("lbl_videoid")).Text);
            string MediaName = ((Label)e.Item.FindControl("lbl_mediapath")).Text;

            //// process and generate thumb changer script
            string thumb_start_index = "";
            if (MediaName.Contains("_"))
                thumb_start_index = MediaName.Remove(MediaName.LastIndexOf("_"));

            string str = "";
            str = str + "stat['" + thumb_start_index + "']=0;";
            str = str + "pic['" + thumb_start_index + "']=new Array();";
            str = str + "pics['" + thumb_start_index + "']=new Array(0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1);";
            this.ThumbRoTator = this.ThumbRoTator + str;

            HyperLink lnk = (HyperLink)e.Item.FindControl("lnk_edit");
            if (LoadFavorites || LoadLiked)
            {
                lnk.Visible = false;
            }
            else
            {
                // Video Status
                Label status = (Label)e.Item.FindControl("lbl_status");
                int ispublished = Convert.ToInt32(((Label)e.Item.FindControl("lbl_ispublished")).Text);
                int errorcode = Convert.ToInt32(((Label)e.Item.FindControl("lbl_errorcode")).Text);
                int isreviewed = Convert.ToInt32(((Label)e.Item.FindControl("lbl_isapproved")).Text);
                int isenabled = Convert.ToInt32(((Label)e.Item.FindControl("lbl_isenabled")).Text);
                if (errorcode > 0)
                {
                    status.Text = "This video is not properly published by our system.";
                    status.CssClass = "mini-text red bold";
                }

                if (isenabled == 0)
                {
                    status.Text = "Video has been blocked or disapproved or still in progress";
                    status.CssClass = "mini-text red bold";
                }

                if (isreviewed == 0)
                {
                    status.Text = "Video is pending for moderator approval";
                    status.CssClass = "mini-text red bold";
                }
              
                lnk.NavigateUrl = Config.GetUrl("myaccount/UpdateVideoInfo.aspx?vid=" + VideoID + "");
            }
           
        }
    }

    protected void rptPages_ItemCommand(object source, RepeaterCommandEventArgs e)
    {
        LinkButton btnPage = (LinkButton)e.Item.FindControl("btnPage");
        PageNumber = int.Parse(btnPage.Text);
        BindList();
    }


    protected void rptPages_ItemDataBound(object sender, RepeaterItemEventArgs e)
    {
        if (e.Item.ItemType == ListItemType.Item || e.Item.ItemType == ListItemType.AlternatingItem)
        {           
            LinkButton btnPage = (LinkButton)e.Item.FindControl("btnPage");
            if (int.Parse(btnPage.Text) == PageNumber)
            {
                System.Web.UI.HtmlControls.HtmlGenericControl li = (System.Web.UI.HtmlControls.HtmlGenericControl)e.Item.FindControl("nav");
                li.Attributes.Add("class", "active");
            }
        }
    }

    protected void lnk_Next_Click(object sender, EventArgs e)
    {
        PageNumber = PageNumber + 1;
        BindList();
    }
    protected void lnk_Prev_Click(object sender, EventArgs e)
    {
        PageNumber = PageNumber - 1;
        BindList();
    }

    // Setup Video Sorting Navigation
    private void Setup_Video_Navigation()
    {
        StringBuilder str = new StringBuilder();
        string _rooturl = Config.GetUrl();
        string _url = _rooturl + "myaccount/MyVideos.aspx";
        if (this.MediaType == 1)
        {
            if (LoadFavorites)
                _url = _rooturl + "myaccount/audio/MyFavorites.aspx";
            else if (LoadLiked)
                _url = _rooturl + "myaccount/audio/My_Liked_Audio.aspx";
        }
        else
        {
            if (LoadFavorites)
                _url = _rooturl + "myaccount/MyFavorites.aspx";
            else if (LoadLiked)
                _url = _rooturl + "myaccount/My_Liked_Videos.aspx";
        }
        string _title_url = "<a href=\"" + _url + "?o=0\">" + Resources.vsk.title + "</a>";
        string _time_url = "<a href=\"" + _url + "?o=1\">" + Resources.vsk.time + "</a>";
        string _date_url = "<a href=\"" + _url + "?o=2\">" + Resources.vsk.dateadded + "</a>";
        string _view_url = "<a href=\"" + _url + "?o=3\">" + Resources.vsk.views + "</a>";
        string _rating_url = "<a href=\"" + _url + "?o=4\">" + Resources.vsk.rating + "</a>";

        int index = 2;
        if (Request.Params["o"] != null)
        {
            index = Convert.ToInt32(Request.Params["o"]);
        }
        // active link
        switch (index)
        {
            case 0:
                _title_url = "<strong class=\"underline\">" + Resources.vsk.title + "</strong>"; // title link active
                break;
            case 1:
                _time_url = "<strong class=\"underline\">" + Resources.vsk.time + "</strong>"; // time link active
                break;
            case 2:
                _date_url = "<strong class=\"underline\">" + Resources.vsk.dateadded + "</strong>"; // date link active
                break;
            case 3:
                _view_url = "<strong class=\"underline\">" + Resources.vsk.views + "</strong>"; // views link active
                break;
            case 4:
                _rating_url = "<strong class=\"underline\">" + Resources.vsk.rating + "</strong>"; // rating link active
                break;
        }

        // create navigation links
        str.Append("<ul>");
            str.Append("<li>" + _title_url + "</li>");
            str.Append("<li class=\"separator\">|</li>");
            str.Append("<li>" + _time_url + "</li>");
            str.Append("<li class=\"separator\">|</li>");
            str.Append("<li>" + _date_url + "</li>");
            str.Append("<li class=\"separator\">|</li>");
            str.Append("<li>" + _view_url + "</li>");
            str.Append("<li class=\"separator\">|</li>");
            str.Append("<li>" + _rating_url + "</li>");
        str.Append("</ul>");

        s_nav.InnerHtml = str.ToString();
    }


    protected void btn_delete_Click(object sender, EventArgs e)
    {
        if (LoadFavorites)
            Delete_Favorites();
        else if (LoadLiked)
            Add_To_Favorites();
        else
            Delete_Videos();
    }
    protected void btn_bsave_Click(object sender, EventArgs e)
    {
        if (LoadFavorites)
            Delete_Favorites();
        else if (LoadLiked)
            Add_To_Favorites();
        else
            Delete_Videos();
    }

    private void Delete_Videos()
    {
        int index = 0;
        bool flg = false;
        for (index = 0; index <= MyList.Items.Count - 1; index++)
        {
            CheckBox select_chk;
            select_chk = (CheckBox)MyList.Items[index].FindControl("chk_vd");
            if (select_chk.Checked)
            {
                long VideoID= int.Parse(((Label)MyList.Items[index].FindControl("lbl_videoid")).Text);
                VideoBLL.RemoveVideo(VideoID, this.MediaType);
                if (flg == false)
                    flg = true;
            }
        }
        if (flg == false)
            Config.ShowMessageV2(msg, Resources.vsk.message_01, "Info!", 2); // "Please select record."
        else
            Config.ShowMessageV2(msg, Resources.vsk.message_myvideos_01, "Success!", 1); // Video has been deleted successfully

        BindList();

    }

    private void Delete_Favorites()
    {
        int index = 0;
        bool flg = false;
        for (index = 0; index <= MyList.Items.Count - 1; index++)
        {
            CheckBox select_chk;
            select_chk = (CheckBox)MyList.Items[index].FindControl("chk_vd");
            if (select_chk.Checked)
            {
                long VideoID = int.Parse(((Label)MyList.Items[index].FindControl("lbl_videoid")).Text);
                Favorites.Delete(VideoID, Page.User.Identity.Name, this.MediaType, 0);
                // update qa favorite statistics
                int fav = Convert.ToInt32(VideoBLL.Get_Field_Value(VideoID, "favorites"));
                if (fav > 0)
                    fav = fav - 1;
                VideoBLL.Update_Field(VideoID, fav.ToString(), "favorites");
            }
        }

        if (flg == false)
            Config.ShowMessageV2(msg, Resources.vsk.message_01, "Info!", 2); // "Please select record."
        else
            Config.ShowMessageV2(msg, Resources.vsk.message_fav_02, "Success!", 1); // Selected videos have been deleted from favorite list.

        BindList();

    }

    // Add videos or audio files to favorites
    private void Add_To_Favorites()
    {
        int index = 0;
        bool flg = false;
        bool alreadyexist = false;
        for (index = 0; index <= MyList.Items.Count - 1; index++)
        {
            CheckBox select_chk;
            select_chk = (CheckBox)MyList.Items[index].FindControl("chk_vd");
            if (select_chk.Checked)
            {
                long VideoID = int.Parse(((Label)MyList.Items[index].FindControl("lbl_videoid")).Text);
                if (!Favorites.Check_Favorites(Page.User.Identity.Name, VideoID, 0))
                {
                    Favorites.Add(Page.User.Identity.Name, VideoID, this.MediaType, 0);
                    // update video favorite statistic
                    int fav = Convert.ToInt32(VideoBLL.Get_Field_Value(VideoID, "favorites"));
                    fav = fav + 1;
                    VideoBLL.Update_Field(VideoID, fav.ToString(), "favorites");
                }
                else
                {
                    alreadyexist = true;
                }

                if (flg == false)
                    flg = true;
            }
        }

        if (flg == false)
            Config.ShowMessageV2(msg, Resources.vsk.message_01, "Info!", 2); // please select record
        else
        {
            if (alreadyexist)
            {
                Config.ShowMessageV2(msg, "Some selection failed to add in your favorites!", "Already Exist Error!", 0); // Selected videos have been added to your favorites.
            }
            else
            {
                Config.ShowMessageV2(msg, Resources.vsk.message_fav_03, "Success!", 1); // Selected videos have been added to your favorites.
            }
        }

        BindList();

    }

    private void LoadSettings()
    {
        if (LoadFavorites)
        {
            MyList.RepeatColumns = 4;
            MyList.RepeatDirection = RepeatDirection.Horizontal;
            norec.InnerHtml = Resources.vsk.message_fav_01;
            //btn_delete.Visible = false;
            //btn_bsave.Visible = false;
        }
        else if (LoadLiked)
        {
            MyList.RepeatColumns = 4;
            MyList.RepeatDirection = RepeatDirection.Horizontal;
            norec.InnerHtml = "No Media Files liked yet!";
            btn_delete.Text = Resources.vsk.addtofavorites;
            btn_bsave.Text = Resources.vsk.addtofavorites;
            //btn_delete.Visible = false;
            //btn_bsave.Visible = false;
        }
        else
        {
            norec.InnerHtml = Resources.vsk.message_myvideos_04;
        }
    }
}
