﻿using System;
using System.Collections.Generic;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Text;
using System.Text.RegularExpressions;

public partial class video2_modules_vd_info : System.Web.UI.UserControl
{
    public bool ShowLikeBox = true;
    public string PostedCaption = "Published on";
    // Normal Properties
    private long _contentid = 0;
    private string _username = "";
    private string _description = "";
    private DateTime _added_date = DateTime.Now;
    private int _categoryid = 0;
    private string _categoryname = "";
    private string _tags = "";
    private int _mediatype = 0;
    private int _liked = 0;
    private int _disliked = 0;
    private int _tagtype = 0;
    private int _categorytype = 0;

    public int MediaType
    {
        set { _mediatype = value; }
        get { return _mediatype; }
    }

    public long ContentID
    {
        set { _contentid = value; }
        get { return _contentid; }
    }

    public string UserName
    {
        set { _username = value; }
        get { return _username; }
    }

    public string Description
    {
        set { _description = value; }
        get { return _description; }
    }

    public int CategoryID
    {
        set { _categoryid = value; }
        get { return _categoryid; }
    }

    public string CategoryName
    {
        set { _categoryname = value; }
        get { return _categoryname; }
    }

    public string Tags
    {
        set { _tags = value; }
        get { return _tags; }
    }

    public DateTime Added_Date
    {
        set { _added_date = value; }
        get { return _added_date; }
    }
       

    public int Liked
    {
        set { _liked = value; }
        get { return _liked; }
    }

    public int Disliked
    {
        set { _disliked = value; }
        get { return _disliked; }
    }

    public int TagType
    {
        set { _tagtype = value; }
        get { return _tagtype; }
    }

    public int CategoryType
    {
        set { _categorytype = value; }
        get { return _categorytype; }
    }

    protected void Page_PreRender(object sender, EventArgs e)
    {
        if (!Page.IsPostBack)
        {
            string _rootpath = Config.GetUrl();
            string usr_url = "<a class=\"mini-text reverse\" href=\"" + _rootpath + "user/" + this.UserName + ".aspx\">" + this.UserName + "</a>";
            Process(usr_url);
        }
    }

    private void Process(string userlink)
    {
        StringBuilder str = new StringBuilder();
        str.Append("<div class=\"row-fluid\">\n");
        str.Append("<div style=\"float:left; width:70%;\">\n");
        str.Append("<div class=\"vsminfo\">\n");
        str.Append(Setup_Main_Info(userlink));
        str.Append("</div>");
        str.Append("<div class=\"vfullinfo\" style=\"display:none;\">\n");
        str.Append(Setup_Full_Video_Info(userlink));
        str.Append("</div>");
        str.Append("</div>\n");
        int totalratings = this.Liked + this.Disliked;
        int per = 0;
        if (this.Disliked == 0)
            per = 100;
        else if(this.Liked >0 && this.Disliked >0)
            per = (int)((this.Liked * 100) / totalratings);
      
        if (this.ShowLikeBox)
        {
            str.Append("<div class=\"prating\" style=\"float:right; width:28%;\">\n");
            str.Append("<div class=\"progress progress-success\" style=\"margin-bottom: 5px;\">\n");
            str.Append("<div class=\"bar\" style=\"width: " + per + "%\"></div>\n");

            str.Append("</div>\n");
            string like = "0";
            if (this.Liked > 0)
                like = string.Format("{0:#,###}", this.Liked);
            string dislike = "0";
            if (this.Disliked > 0)
                dislike = string.Format("{0:#,###}", this.Disliked);
            str.Append("<span class=\"small-text\">" + like + " likes, " + dislike + " dislikes</span>");
            str.Append("</div>\n");
          
        }
        str.Append("</div>\n");
        str.Append("<div class=\"bx_br_tp item_c\">\n");
        str.Append("<button class=\"btn btn-mini vinfobtn\"><i class=\"icon-chevron-down vinfoico\"></i> <span class=\"vinfotxt\">show more</span></button>");
        str.Append("</div>\n");
        info.InnerHtml = str.ToString();
    }
    private string Setup_Main_Info(string userlink)
    {
        StringBuilder str = new StringBuilder();
        // username 
        str.Append("<span class=\"normal-text\">" + PostedCaption + " " + UtilityBLL.Generate_Date(this.Added_Date, 1) + " by </span> " + userlink + "<br />");
        // description
        string desc = UtilityBLL.StripHTML(this.Description);
        if (desc.Length > 100)
            desc = desc.Substring(0, 100);
        
        if (desc == "")
            str.Append("<span class=\"normal-text light\">no description</span><br />\n");
        else
            str.Append("<span class=\"medium-text\">" + desc + "</span>");

        return str.ToString();
    }

    // Setup Full Video Information
    private string Setup_Full_Video_Info(string userlink)
    {
        StringBuilder str = new StringBuilder();
        // username
        str.Append("<span class=\"normal-text\">" + PostedCaption + " " + UtilityBLL.Generate_Date(this.Added_Date, 1) + " by </span> " + userlink + "<br />");
        if (this.Description == "")
            str.Append("<span class=\"normal-text light\">no description</span><br />\n");
        else
            str.Append(this.Description + "<br /><br />");

        // multi category implementation
        if (this.CategoryName != "")
            str.Append("File Under: " + UGeneral.Prepare_Categories(this.CategoryName, 0, "normal-text bold", this.CategoryType) + "<br />\n");
        if (this.Tags != "")
            str.Append("Tags: " + UGeneral.Prepare_Tags(this.Tags, 0, "normal-text bold", this.TagType) + "<br />\n");

        return str.ToString();
    }
}