﻿using System;
using System.Collections;
using System.Configuration;
using System.Data;
using System.Web;
using System.Web.Security;
using System.Web.UI;

using System.Web.UI.WebControls;
using System.Text;
using System.Web.UI.HtmlControls;

public partial class videos_Default : System.Web.UI.Page
{
    private int Filter = 0;
    protected string NavigationClass = "";
    protected string BodyClass = "";
    protected string BodyRight = "";

    protected void Page_Load(object sender, EventArgs e)
    {
        // process website layout
        Process_Layout();

        if (!Page.IsPostBack)
        {
            lst1.isListStatus = true;
            lst1.isListNav = true;
            lst1.Term = "";
            lst1.SearchType = 0;
            lst1.isFeatured = 2; // All Featured and Normal Videos
            lst1.isPrivate = 0; // Load only public videos
            lst1.isCache = true; // load and cache records
            lst1.PageSize = Site_Settings.Video_Page_Size;
            if (Request.Params["added"] != null)
            {
                lst1.AddedFilter = Convert.ToInt32(Request.Params["added"]);
                lst1.isListNav = false;
            }
            Filter = Set_Filter();
            if (Filter > 0)
            {
                lst1.Order = "ve.added_date";
                lst1.Filter = Filter;
            }
            else
            {
                lst1.Order = "v.date_added desc, v.liked desc, v.views desc";
            }

            lst1.TabIndex = 0; // Recently Added (Selected)
            // setup patination / navigation urls
            Setup_Urls(Filter);
            // set page title, description etc
            PageInfoSetup();

            set_bread_links();

        }

    }

    private void PageInfoSetup()
    {
        string FilterOption = "";
        string NoRecordFoundOption = Resources.vsk.uploadedyet; // "Upload Yet";
        switch (Filter)
        {
            case 1:
                // today viewed
                FilterOption = " - " + Resources.vsk.todayviewed; // "Today Viewed";
                NoRecordFoundOption = Resources.vsk.viewedtoday; // "Viewed Today";
                break;
            case 2:
                // this week viewed
                FilterOption = " - " + Resources.vsk.thisweekviewed; // "This Week Viewed";
                NoRecordFoundOption = Resources.vsk.viewedthisweek; // "Viewed This Week";
                break;
            case 3:
                // this month viewed
                FilterOption = " - " + Resources.vsk.thismonthviewed; // "This Month Viewed";
                NoRecordFoundOption = Resources.vsk.viewedthismonth;// "Viewed This Month";
                break;
        }
        string AddedCaption = "";
        if (Request.Params["added"] != null)
        {
            switch (Request.Params["added"].ToString())
            {
                case "1":
                    AddedCaption = Resources.vsk.todayadded + " " + Resources.vsk.videos; // "Today Added Videos";
                    NoRecordFoundOption = Resources.vsk.novideosadded + " " + Resources.vsk.today; // "No Videos Added Today";
                    break;
                case "2":
                    AddedCaption = Resources.vsk.thisweekadded + " " + Resources.vsk.videos; // "This Week Added Videos";
                    NoRecordFoundOption = Resources.vsk.novideosadded + " " + Resources.vsk.thisweek; // "No Videos Added This Week";
                    break;
                case "3":
                    AddedCaption = Resources.vsk.thismonthadded + " " + Resources.vsk.videos; // "This Month Added Videos";
                    NoRecordFoundOption = Resources.vsk.novideosadded + " " + Resources.vsk.thismonth; // "No Videos Added This Month";
                    break;
            }
            lst1.PageTitle = "" + FilterOption + " " + AddedCaption;
            lst1.PageDescription = " " + FilterOption.ToLower() + " " + AddedCaption.ToLower();
            lst1.NoRecordFoundText = NoRecordFoundOption + "!";
        }
        else
        {
            lst1.PageTitle = "Recently Added Videos " + FilterOption; // Resources.vsk.videos_recentlyadded_title.Replace("[filter]", FilterOption); // "" + FilterOption + " Recently Added Videos ";
            lst1.PageDescription = "Browse list of videos recently uploaded " + FilterOption.ToLower(); // Resources.vsk.videos_recentlyadded_desc.Replace("[filter]", FilterOption.ToLower()); // "Browse " + FilterOption.ToLower() + " recently added Videos ";
            lst1.NoRecordFoundText = "No videos " + NoRecordFoundOption; // Resources.vsk.videos_recentlyadded_notfound.Replace("[filter]", NoRecordFoundOption); // "No Videos  " + NoRecordFoundOption + "!";
        }
    }

    private void Setup_Urls(int Filter)
    {
        string filterurl = "";
        if (Request.Params["filter"] != null)
            filterurl = Request.Params["filter"].ToString().ToLower();
        lst1.DefaultUrl = "videos/";
        lst1.Filter_DefaultUrl = "videos/default/" + filterurl + ".aspx";
        lst1.Pagination_Url = "videos/[p]/default.aspx"; // [p] dynamically populate with pagenumber e.g /[p]/ ... /pagenumber/ ... /345/;
        lst1.Filter_Pagination_Url = "videos/default/[p]/" + filterurl + ".aspx";
        // top navigation urls
        if (Filter > 0)
        {
            lst1.Recent_Url = "videos/default/" + filterurl + ".aspx";
            lst1.MostViewed_Url = "videos/mostviewed/" + filterurl + ".aspx";
            lst1.Toprated_Url = "videos/toprated/" + filterurl + ".aspx";
            lst1.MostFavorited_Url = "videos/mostfavorited" + filterurl + ".aspx";
            lst1.MostCommented_Url = "videos/mostcommented" + filterurl + ".aspx";
        }
        else
        {
            lst1.Recent_Url = "videos/";
            lst1.MostViewed_Url = "videos/mostviewed.aspx";
            lst1.MostFavorited_Url = "videos/mostfavorited.aspx";
            lst1.Toprated_Url = "videos/toprated.aspx";
            lst1.MostCommented_Url = "videos/mostcommented" + filterurl + ".aspx";
        }
    }

    private void set_bread_links()
    {
        string _rooturl = Config.GetUrl();
        StringBuilder str = new StringBuilder();
        str.Append("<li><a href=\"" + _rooturl + "\">" + Resources.vsk.home + "</a><span class=\"divider\">/</span> </li>\n");
        str.Append("<li class=\"active\">Recent Videos</li>\n");
        bread.InnerHtml = str.ToString();
    }

    private int Set_Filter()
    {
        int filter = 0;
        if (Request.Params["filter"] != null)
        {
            switch (Request.Params["filter"].ToString().ToLower())
            {
                case "all":
                    filter = 0;
                    break;
                case "thismonth":
                    filter = 3;
                    break;
                case "thisweek":
                    filter = 2;
                    break;
                case "today":
                    filter = 1;
                    break;
            }
        }
        return filter;
    }

    // Core script to handle website layout
    private void Process_Layout()
    {
        UGeneral ug = new UGeneral();
        int selected_layout_option = Site_Settings.NavigationSection;
        if (selected_layout_option == 2)
        {
            // three column layout
            navigation1.Visible = false; // advance navigation disable
            navigation_sm1.Visible = true; // first column simple navigation
            third_nav1.Visible = true; // third column navigation
        }
        else
        {
            // two column layout
            navigation1.Visible = true;
            navigation_sm1.Visible = false;
            third_nav1.Visible = false;
        }

        NavigationClass = ug.Return_Navigation_Class();
        BodyClass = ug.Return_Body_Class();
        BodyRight = ug.Return_RightNav_Class();

    }
}
